Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class Closure<T extends Item>

    java.lang.Object
      net.sf.saxon.value.Value<T>
          net.sf.saxon.value.Closure<T>

All Implemented Interfaces:
  ValueRepresentation<T>

Direct Known Subclasses:
  MemoClosure, SingletonClosure

    public class Closure<T extends Item>

extends Value<T>

A Closure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

This Closure is designed for use when the value is only read once. If the value is read more than once, a new iterator over the underlying expression is obtained each time: this may (for example in the case of a filter expression) involve significant re-calculation.

The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

Field Summary
`protected int` | `depth`
`protected Expression` | `expression`
`protected SequenceIterator<T>` | `inputIterator`
`protected XPathContextMajor` | `savedXPathContext`

Fields inherited from class net.sf.saxon.value.Value
`INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`Closure()` Constructor should not be called directly, instances should be made using the make() method.

Method Summary
`int` | `getCardinality()` Get the cardinality
`Expression` | `getExpression()`
`ItemType` | `getItemType(TypeHierarchy th)` Get the static item type
`XPathContextMajor` | `getSavedXPathContext()`
`SequenceIterator<T>` | `iterate()` Evaluate the expression in a given context to return an iterator over a sequence
`static Value` | `make(Expression expression, XPathContext context, int ref)` Construct a Closure by supplying the expression and the set of context variables.
`static
`<T extends Item> ValueRepresentation<T>`
` | `makeIteratorClosure(SequenceIterator<T> iterator)` Construct a Closure over an existing SequenceIterator.
`void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
`Value<T>` | `reduce()` Reduce a value to its simplest form.
`void` | `saveContext(Expression expression, XPathContext context)`
`void` | `setExpression(Expression expression)`
`void` | `setSavedXPathContext(XPathContextMajor savedXPathContext)`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, checkPermittedContents, convertToJava, effectiveBooleanValue, equals, fromItem, getCanonicalLexicalRepresentation, getIterator, getLength, getSchemaComparable, getSequenceLength, getStringValue, getStringValueCS, hashCode, isIdentical, itemAt`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### expression

    protected Expression expression

### savedXPathContext

    protected XPathContextMajor savedXPathContext

### depth

    protected int depth

### inputIterator

    protected SequenceIterator<T extends Item> inputIterator

Constructor Detail

### Closure

    public Closure()

  Constructor should not be called directly, instances should be made using the make() method.

Method Detail

### makeIteratorClosure

    public static <T extends Item> ValueRepresentation<T> makeIteratorClosure(SequenceIterator<T> iterator)
                                                                   throws XPathException

  Construct a Closure over an existing SequenceIterator. This is used when an extension function returns a SequenceIterator as its result (it replaces the old SequenceIntent class for this purpose). There is no known expression in this case. Note that the caller must ensure this is a "clean" iterator: it must be positioned at the start, and must not be shared by anyone else.

  Parameters:
    `iterator` - the supplied iterator
  Returns:
    the Closure over this iterator
  Throws:
    `XPathException` - if a dynamic error occurs

### make

    public static Value make(Expression expression,
                             XPathContext context,
                             int ref)
                      throws XPathException

  Construct a Closure by supplying the expression and the set of context variables.

  Parameters:
    `expression` - the expression to be lazily evaluated
    `context` - the dynamic context of the expression including for example the variables on which it depends
    `ref` - the number of references to the value being lazily evaluated; this affects the kind of Closure that is created
  Returns:
    the Closure, a virtual value that can later be materialized when its content is required
  Throws:
    `XPathException` - if a dynamic error occurs

### saveContext

    public void saveContext(Expression expression,
                            XPathContext context)
                     throws XPathException

  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the static item type

  Overrides:
    `getItemType` in class `Value<T extends Item>`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    for the default implementation: AnyItemType (not known)

### getCardinality

    public int getCardinality()

  Get the cardinality

  Overrides:
    `getCardinality` in class `Value<T extends Item>`
  Returns:
    the cardinality

### getExpression

    public Expression getExpression()

### getSavedXPathContext

    public XPathContextMajor getSavedXPathContext()

### setExpression

    public void setExpression(Expression expression)

### setSavedXPathContext

    public void setSavedXPathContext(XPathContextMajor savedXPathContext)

### iterate

    public SequenceIterator<T> iterate()
                                             throws XPathException

  Evaluate the expression in a given context to return an iterator over a sequence

  Specified by:
    `iterate` in class `Value<T extends Item>`
  Returns:
    an iterator over the sequence of items
  Throws:
    `XPathException` - if a dynamic error occurs. This is possible only in the case of values that are materialized lazily, that is, where the iterate() method leads to computation of an expression that delivers the values.

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Overrides:
    `process` in class `Value<T extends Item>`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException` - if an error occurs (for example if the value is a closure that needs to be evaluated)

### reduce

    public Value<T> reduce()
                                 throws XPathException

  Reduce a value to its simplest form. If the value is a closure or some other form of deferred value such as a FunctionCallPackage, then it is reduced to a SequenceExtent. If it is a SequenceExtent containing a single item, then it is reduced to that item. One consequence that is exploited by class FilterExpression is that if the value is a singleton numeric value, then the result will be an instance of NumericValue

  Overrides:
    `reduce` in class `Value<T extends Item>`
  Returns:
    the value in simplified form
  Throws:
    `XPathException` - if an error occurs

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.